#include "BoodskapMessage.h"

BoodskapMessage::BoodskapMessage(unsigned int messageId, JsonBuffer& buffer, const char* domainKey, const char* assetId, const char* apiKey, const char* fwVersion, DeviceModel devModel):
  _domainKey(domainKey), _assetId(assetId), _apiKey(apiKey), _fwVersion(fwVersion), _devModel(devModel), _msg(0), _header(0), _data(0)
{
  _msg = &buffer.createObject();
  _header = &_msg->createNestedObject("header");
  _data = &_msg->createNestedObject("data");

  (*_header)["key"] = _domainKey;
  (*_header)["mid"] = messageId;
  (*_header)["aid"]   = _assetId;
  (*_header)["api"]  = _apiKey;
  (*_header)["dmdl"]  = DeviceModelNames[_devModel];
  (*_header)["fwver"]  = _fwVersion;

}

JsonObject& BoodskapMessage::get(){return *_msg;}

JsonObject& BoodskapMessage::header(){return *_header;}

JsonObject& BoodskapMessage::data(){return *_data;};

void BoodskapMessage::compact(){
  _header->remove("dmdl");
  _header->remove("fwver");
}

JsonObject& BoodskapMessage::set(const char* field, uint8_t val){
  (*_data)[field]  = val;
  return data();
}

JsonObject& BoodskapMessage::set(const char* field, bool val){
  (*_data)[field]  = val;
  return data();
}

JsonObject& BoodskapMessage::set(const char* field, int val){
  (*_data)[field]  = val;
  return data();
}

JsonObject& BoodskapMessage::set(const char* field, uint16_t val){
  (*_data)[field]  = val;
  return data();
}

JsonObject& BoodskapMessage::set(const char* field, uint32_t val){
  (*_data)[field]  = val;
  return data();
}

JsonObject& BoodskapMessage::set(const char* field, float val){
  (*_data)[field]  = val;
  return data();
}

JsonObject& BoodskapMessage::set(const char* field, double val){
  (*_data)[field]  = val;
  return data();
}

JsonObject& BoodskapMessage::set(const char* field, long val){
  (*_data)[field]  = val;
  return data();
}

JsonObject& BoodskapMessage::set(const char* field, const char* val){
  (*_data)[field]  = val;
  return data();
}

JsonObject& BoodskapMessage::set(const char* field, String val){
  (*_data)[field]  = val;
  return data();
}

